function [y_hat theta y_hatv]=PWASON(phi,y,lambda,N)
y_hatv=[];
[T n_phi]=size(phi);
Phi=zeros(n_phi*T,T);
for t=1:T
    Phi(n_phi*(t-1)+1:n_phi*t,t)=phi(t,:);
end

%%
W1=zeros(T,T*(T-1)/2);
i=1;
for t=1:T
    [D ind]=sort(sum(([phi(t,:) y(t)]'*ones(1,T)-[phi y']').^2,1));
    for tt=1:T
        if sum(tt==ind(2:N+1));
            W1(t,i)=1;W1(tt,i)=-1;
            i=i+1;
        end
    end
end

%%
alpha=ones(1,T*(T-1)/2);
M=2; 
for dummy=1:M
    cvx_begin
    variables  theta(n_phi,T)
    minimize( ...
        sum((y-reshape(theta,1,n_phi*T)*Phi).^2)...
        +lambda*(...
        sum(norms((ones(n_phi,1)*alpha).*(theta*W1),2,1))  ...
        ))
    cvx_end
    alpha=1./(0.98+norms(theta*W1,2,1));
    y_hat=reshape(theta,1,n_phi*T)*Phi;
    if dummy==M-1
        alpha(norms(theta*W1,2,1)>2)=0;
        alpha(norms(theta*W1,2,1)<2)=1000;
    end
end
